define(["require", "exports", "./provide_when_on_syntax", "./provide_when_syntax", "./provide_on_syntax", "./provide_done_syntax"], function (require, exports, provide_when_on_syntax_1, provide_when_syntax_1, provide_on_syntax_1, provide_done_syntax_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var ProvideInSyntax = /** @class */ (function () {
        function ProvideInSyntax(bindingInSyntax, provideDoneSyntax) {
            this._bindingInSyntax = bindingInSyntax;
            this._provideDoneSyntax = provideDoneSyntax;
        }
        ProvideInSyntax.prototype.inSingletonScope = function () {
            var _this = this;
            var bindingWhenOnSyntax = function (bind, target) {
                return _this._bindingInSyntax(bind, target).inSingletonScope();
            };
            var inDoneSyntax = new provide_done_syntax_1.default(bindingWhenOnSyntax);
            var provideWhenSyntax = new provide_when_syntax_1.default(bindingWhenOnSyntax, inDoneSyntax);
            var provideOnSyntax = new provide_on_syntax_1.default(bindingWhenOnSyntax, inDoneSyntax);
            return new provide_when_on_syntax_1.default(provideWhenSyntax, provideOnSyntax);
        };
        ProvideInSyntax.prototype.inTransientScope = function () {
            var _this = this;
            var bindingWhenOnSyntax = function (bind, target) { return _this._bindingInSyntax(bind, target).inTransientScope(); };
            var inDoneSyntax = new provide_done_syntax_1.default(bindingWhenOnSyntax);
            var provideWhenSyntax = new provide_when_syntax_1.default(bindingWhenOnSyntax, inDoneSyntax);
            var provideOnSyntax = new provide_on_syntax_1.default(bindingWhenOnSyntax, inDoneSyntax);
            return new provide_when_on_syntax_1.default(provideWhenSyntax, provideOnSyntax);
        };
        ProvideInSyntax.prototype.done = function (force) {
            return this._provideDoneSyntax.done(force);
        };
        return ProvideInSyntax;
    }());
    exports.default = ProvideInSyntax;
});
